/*
 *
 * $Id$
 *
 */

/*****************************************************************************
 *
 * file:   calloc.c
 *
 * prefix: none
 *
 * description:
 *
 *   This file provides a SAC heap manager specific implementations of the
 *   function calloc().
 *
 *   Although programs generated by sac2c will never use this function,
 *   it is nevertheless mandatory because functions from external module
 *   or class implementation might rely on it.
 *
 *
 *****************************************************************************/

#include <string.h>

#include "heapmgr.h"

/*****************************************************************************
 *
 * function:
 *   void *calloc(size_t nelem, size_t elsize)
 *
 * description:
 *
 *   SAC heap manager specific implementation of calloc().
 *
 *
 *
 *****************************************************************************/

void *
calloc (size_t nelem, size_t elsize)
{
    void *res;

    DIAG_INC_LOCK (SAC_HM_call_calloc);
    DIAG_DEC_LOCK (SAC_HM_call_malloc);

    res = malloc (nelem * elsize);

    res = memset (res, 0, nelem * elsize);

    return (res);
}
